var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { sleep } from './sleep';
var defaultOptions = {
    retries: 3,
    delay: 0,
    timeout: 0
};
/**
 * Executes provided `action` and returns its value.
 * If `action` throws or rejects, it will retry execution
 * several times before failing.
 *
 * @param action sync or async callback
 * @param options customize behavior
 */
export function retry(action, options) {
    return __awaiter(this, void 0, void 0, function () {
        var _a, retries, delay, timeout, lastError, timedOut, timeoutId, timeoutPromise, maxAttempts, attemptCount, actionResult, result, e_1, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _a = __assign({}, defaultOptions, options), retries = _a.retries, delay = _a.delay, timeout = _a.timeout;
                    timedOut = false;
                    timeoutPromise = new Promise(function (_res, rej) {
                        if (timeout > 0) {
                            timeoutId = setTimeout(function () {
                                timedOut = true;
                                if (!lastError) {
                                    lastError = new Error("timed out after " + timeout + "ms");
                                }
                                rej();
                            }, timeout);
                        }
                    });
                    maxAttempts = retries + 1;
                    attemptCount = 0;
                    _c.label = 1;
                case 1:
                    attemptCount++;
                    _c.label = 2;
                case 2:
                    _c.trys.push([2, 4, , 5]);
                    actionResult = action();
                    if (actionResult instanceof Promise) {
                        // make sure we always save error of original promise
                        // Promise.race below might loose it due to timeout
                        actionResult.catch(function (e) { return lastError = e || lastError; });
                    }
                    return [4 /*yield*/, Promise.race([actionResult, timeoutPromise])];
                case 3:
                    result = _c.sent();
                    clearTimeout(timeoutId);
                    return [2 /*return*/, result];
                case 4:
                    e_1 = _c.sent();
                    lastError = e_1 || lastError;
                    return [3 /*break*/, 5];
                case 5:
                    if (!(delay > 0)) return [3 /*break*/, 9];
                    _c.label = 6;
                case 6:
                    _c.trys.push([6, 8, , 9]);
                    return [4 /*yield*/, Promise.race([sleep(delay), timeoutPromise])];
                case 7:
                    _c.sent();
                    return [3 /*break*/, 9];
                case 8:
                    _b = _c.sent();
                    return [3 /*break*/, 9];
                case 9:
                    if (!timedOut && (attemptCount < maxAttempts)) return [3 /*break*/, 1];
                    _c.label = 10;
                case 10:
                    clearTimeout(timeoutId);
                    throw (lastError || new Error("failed after " + attemptCount + " tries"));
            }
        });
    });
}
export function waitFor(action, options) {
    return retry(action, __assign({ delay: 10, timeout: 500, retries: Infinity }, options));
}
//# sourceMappingURL=retry.js.map